//////////////////////////////////////////////////////////////////////////////
// Trigonometric Functions
//
// Last update: 25/09/2009
//////////////////////////////////////////////////////////////////////////////
package applet;

import java.applet.Applet;
import java.lang.String;
import java.math.BigDecimal;
import java.math.BigInteger;
import org.apfloat.ApfloatContext;
import org.apfloat.Apfloat;
import org.apfloat.ApfloatMath;
import java.util.Properties;
import java.lang.ArithmeticException;


public class TrigonometricFunctions extends Applet
{
    private static ApfloatContext context;
    private long digits_show = 200;
    private long digits_comp = 400;
    private int idiom = 0;
    protected String[] undefined_trans = {"indefinido",
                                          "undefined"};
    protected Apfloat d2r;
    protected BigInteger bi90;
    protected BigInteger bi0;
     
    static 
    {
        Properties prop = new Properties();
        prop.setProperty("cleanupAtExit", "false");
        context = new ApfloatContext(prop);
        context.setCleanupAtExit(false);
        ApfloatContext.setThreadContext(context);
    }    
    
    public TrigonometricFunctions()
    {
    }
        
    public void init()
    {
        super.init();

    	idiom = Integer.valueOf(getParameter("idiom")).intValue();
    	digits_show = Long.valueOf(getParameter("digits_show")).longValue();
    	digits_comp = Long.valueOf(getParameter("digits_comp")).longValue();
    	d2r = new Apfloat("180", digits_comp);
    	d2r = Apfloat.ONE.divide(d2r);
    	d2r = d2r.multiply(ApfloatMath.pi(2*digits_comp));
    	bi90 = new BigInteger("90");
    	bi0 = new BigInteger("0");

	System.out.println("TrigonometricFunctions() initialized ...");
    }
    
    public String rsin(String a)
    {
	    BigDecimal bd = new BigDecimal(a);
	    Apfloat angle = new Apfloat(bd, digits_comp);
	    Apfloat value = ApfloatMath.sin(angle);
	    String result = value.precision(digits_comp).toString(true);
	    return(result.substring(0, (int) digits_show));
    }
    
    public String dsin(String a)
    {
	    BigDecimal bd = new BigDecimal(a);
	    Apfloat angle = new Apfloat(bd, digits_comp);
	    angle = angle.multiply(d2r);
	    Apfloat value = ApfloatMath.sin(angle);
	    String result = value.precision(digits_comp).toString(true);
	    return(result.substring(0, (int) digits_show));
    }
        
    public String rcos(String a)
    {
	    BigDecimal bd = new BigDecimal(a);
	    Apfloat angle = new Apfloat(bd, digits_comp);
	    Apfloat value = ApfloatMath.cos(angle);
	    String result = value.precision(digits_comp).toString(true);
	    return(result.substring(0, (int) digits_show));
    }

    public String dcos(String a)
    {
	    BigDecimal bd = new BigDecimal(a);
	    Apfloat angle = new Apfloat(bd, digits_comp);
	    angle = angle.multiply(d2r);	    
	    Apfloat value = ApfloatMath.sin(angle);
	    String result = value.precision(digits_comp).toString(true);
	    return(result.substring(0, (int) digits_show));
    }    
    
    public String rtan(String a)
    {
	    BigDecimal bd = new BigDecimal(a);
	    Apfloat angle = new Apfloat(bd, digits_comp);
	    try
	    {
	       Apfloat value = ApfloatMath.tan(angle);
		   String result = value.precision(digits_comp).toString(true);
		   return(result.substring(0, (int) digits_show));	       
	    }
	    catch (Exception e)
	    {
	       return(undefined_trans[idiom]);	
	    }
    }
    
    public String dtan(String a)
    {
	    BigDecimal bd = new BigDecimal(a);
	    Apfloat angle = new Apfloat(bd, digits_comp);
	    angle = angle.multiply(d2r);
	    try
	    {
	       Apfloat value = ApfloatMath.tan(angle);
		   String result = value.precision(digits_comp).toString(true);
		   return(result.substring(0, (int) digits_show));	       
	    }
	    catch (Exception e)
	    {
	       return(undefined_trans[idiom]);	
	    }
    }    
    
    public boolean checkAngle(String a)
    {
    	if (a.length() == 0)
    	{
    		return(true);
    	}
    	else
    	{
    		if (a.indexOf(".") != -1)
    		{
    		   return(true);	
    		}
    		else
    		{
    		   BigInteger bi = new BigInteger(a);
    		   if (bi.remainder(bi90).compareTo(bi0) != 0)
    		   {
    			   return(true);
    		   }
    		   else
    		   {
    			   return(false);
    		   }
    		}
    	}
    }
}
