///////////////////////////////////////////////////////////////////////////////
// Cylinder Interface class
//
// Last update: 29/06/2005
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Native JAVA imports
///////////////////////////////////////////////////////////////////////////////
import java.awt.Panel;
import java.awt.TextField;
import java.awt.FlowLayout;
import java.awt.Label;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Checkbox;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

///////////////////////////////////////////////////////////////////////////////
// JavaView imports
///////////////////////////////////////////////////////////////////////////////
import jv.object.PsPanel;
import jv.object.PsUpdateIf;
import jv.project.PjProject_IP;


///////////////////////////////////////////////////////////////////////////////
// Info panel for graph tomography applet.
///////////////////////////////////////////////////////////////////////////////
public class PjCylinder_IP extends PjProject_IP implements ActionListener
{
   protected PjCylinder m_pjCylinder;
   protected Panel m_tPanel; // t panel
      
   protected int idiom = 0;
   protected String[] title_trans = {"Uma Propriedade Interessante do Cilindro",
                                     "An Interesting Property of The Cylinder"};
   
   protected String[] t_trans = {"Parmetro:",
                                 "Parameter:"};
   
   ///////////////////////////////////////////////////////////////////////////
   // Default constructor
   ///////////////////////////////////////////////////////////////////////////
   public PjCylinder_IP()
   {
      super();

      if (getClass() == PjCylinder_IP.class)
      {
         init();
      };
   }; // End of PjCylinder_IP()


   //////////////////////////////////////////////////////////////////////////
   // Setup the main control panel
   //////////////////////////////////////////////////////////////////////////
   public void init()
   {
      // Title
      addTitle(title_trans[idiom]);
      	   
      super.init();
   }; // End of init()


   //////////////////////////////////////////////////////////////////////////
   // Setup parent and add the level slider
   //////////////////////////////////////////////////////////////////////////
   public void setParent(PsUpdateIf parent)
   {
      super.setParent(parent);      
      m_pjCylinder = (PjCylinder) parent;
      idiom = m_pjCylinder.idiom;
      
      // Title
      setTitle(title_trans[idiom]);      
      
      add(new Label(" "));      
   
      addLine(1);
      m_tPanel = new Panel();
      m_tPanel.setLayout(new GridLayout(1, 1));
      add(m_tPanel);
      m_pjCylinder.t.setName(t_trans[idiom]);
      m_tPanel.removeAll();
      m_tPanel.add(m_pjCylinder.t.newInspector(PsPanel.INFO_EXT));
      addLine(1);
      
      m_pjCylinder.updateCamera();

      super.setParent(parent);
   }; // End of setParent()


   //////////////////////////////////////////////////////////////////////////
   // Update the panel whenever the parent has changed somewhere else
   //////////////////////////////////////////////////////////////////////////
   public boolean update(Object  event)
   {
      if (m_pjCylinder == event)
      {
         // Fill here!

         return(true);
      };

      return(super.update(event));
   }; // End of update()

   //////////////////////////////////////////////////////////////////////////
   // Handle action events invoked from text fields
   //////////////////////////////////////////////////////////////////////////
   public void actionPerformed(ActionEvent event)
   {
      if (m_pjCylinder == null)
      {
          return;
      };

      Object source = event.getSource();

      // Fill here!

   }; // End of actionPerformed()
}; // End of PjCylinder_IP class
